import os

from deploy import colorized_output as co
from deploy.mounts import Mounts
from deploy.python_environment import PythonEnvironment
from deploy.repository import Repository

from fabric import Connection

USER = 'ftc'
ROOT = 'root'


class Deployment:
    def __init__(self, host):
        self.host = host
        self.con = Connection(host = host, user = USER)

    def copy_ssh_key(self):
        co.print_warning('Copying SSH credentials (scp)...')
        os.system("scp $HOME/.ssh/id_rsa.pub {0}@{1}:/tmp/credentials.pub".format(ROOT, self.host))
        co.print_warning('Establishing SSH connection (mkdir, chmod, mv)...')
        os.system("ssh {0}@{1} 'mkdir -p /home/ftc/.ssh && chmod 755 /tmp/credentials.pub &&"
                  "mv /tmp/credentials.pub /home/ftc/.ssh/authorized_keys'".format(ROOT, self.host))

    def check_mounts(self):
        mnts = Mounts(self.con)
        mnts.check_mounts()

    def check_pip_and_libraries(self):
        pyenv = PythonEnvironment(self.con)
        pyenv.check_pip()
        pyenv.check_pip_libraries()
        pyenv.add_ftc_path()

    def run_tests(self):
        repo = Repository(self.con)
        repo.uploadFolder('../../tests')
        co.print_info("Starting tests...")
        self.con.run("python3 /home/ftc/tests/txt/main.py")
