import os
from deploy import colorized_output as co

class Repository:
    def __init__(self, connection):
        self.connection = connection

    def uploadFolder(self, folder):
        tar_folder = "{0}.tar".format(folder.split('/')[-1])
        os.system("tar -cf {0} {1}/".format(tar_folder, folder))
        self.connection.put("{0}".format(tar_folder))
        self.connection.run("tar -xf {0}".format(tar_folder))
        self.connection.run("rm {0}".format(tar_folder))
        os.system("rm {0}".format(tar_folder))

    def uploadAppFolder(self, folder):
        self.uploadFolder(folder)
        co.print_info('UploadAppFolder ' + folder)
        self.connection.run("mkdir -p apps", warn=True)
        self.connection.run("rm -rf apps/{0}/".format(folder), warn=True)
        self.connection.run("mv -f {0} apps/".format(folder))
        self.connection.run("chmod +x apps/{0}/start.py".format(folder))
        self.connection.run("python apps/{0}/refresh.py".format(folder))

    def replace_ip(self, ip):
        self.connection.run("cd txtapi/txtapi/openapi && sed -i 's/^host:.*$/host: \"{0}:8080\"/g' openapi.yaml".format(ip))

    def replace_env(self, env_file):
        self.connection.run("mv txtapi/txtapi/environment/{0} txtapi/txtapi/environment/environment.py".format(env_file))