#!/usr/bin/python
# -*- coding: UTF-8 -*-

import os

from deploy.python_environment import PythonEnvironment
from deploy import colorized_output as co
from fabric import Connection
from invoke import env

USER = 'root'
PASSWORD = 'root'


class Deployment:
    def __init__(self, host):
        self.host = host
        env.key_filename = "~/.ssh/id_rsa"
        self.connection = Connection(host=host, user=USER, connect_kwargs={
            "password": PASSWORD
        })

    def check_pip_and_libraries(self):
        pyenv = PythonEnvironment(self.connection)
        pyenv.check_pip_libraries()

    def clean_up(self):
        self.connection.run("rm -rf /tests")
        os.system("cd ../../gen && rm -rf dist build ft_git ft-controllerlib.egg-info")

    def build_package(self):
        os.system('cd ../../gen && ./build.sh')

    def upload_package(self):
        os.system(
            "scp ../../gen/dist/ft-controllerlib-*.tar.gz {0}@{1}:/ft-controllerlib.tar.gz".format(USER, self.host))

    def install_package(self):
        self.connection.run("pip3 install -I /ft-controllerlib.tar.gz")

    def upload_tests(self, folder):
        os.system("scp -r {0} {1}@{2}:/tests".format(folder, USER, self.host))

    def run_tests(self):
        co.print_info("Starting tests...")
        self.connection.run("cd /tests/txt4 && python3 -m unittest discover -p '*Test.py' -v")
