#!/usr/bin/python
# -*- coding: UTF-8 -*-

from deploy import colorized_output as co
import os

class PythonEnvironment:
    def __init__(self, connection):
        self.connection = connection

    def check_pip_libraries(self):
        co.print_info('Checking pip libraries')
        requirements = self.get_requirements()
        pip_list = self.get_pip_list()
        for requirement in requirements:
            search = requirement.strip().replace(' ', '')
            self.check_pip_library(pip_list, search)

    def check_pip_library(self, dependencies, dependency):
        co.print_info("Checking {0}:".format(dependency))
        if dependency in dependencies:
            co.print_success("--> Already installed")
        else:
            co.print_warning("--> Not installed. Starting installation")
            self.connection.run("LC_ALL=en_US.utf8 pip3 install {0}".format(dependency))
            co.print_success("--> Successfully installed")

    def get_pip_list(self):
        return self.connection.run('pip3 list --format=freeze').stdout.strip().split()

    def get_requirements(self):
        fd = open('requirements.txt', 'r')
        return fd.readlines()
