import fischertechnik.factories as txtFactory
from motors.encodermotor_test import EncodermotorTest
from inputs.mini_switch_test import MiniSwitchTest
from lamps.lamp_test import SimpleLampTest
from sensors.photo_transistor_test import PhotoTransistorTest
from sensors.environmental_sensor_test import EnvironmentSensorTest

success = '\033[94m'
failure = '\033[91m'
info = '\033[93m'
reset = '\033[0m'
txtFactory.init_controller_factory()
txt = txtFactory.controller_factory.create_graphical_controller()
tests = []

# Add tests
tests.append(EncodermotorTest(txt))
tests.append(MiniSwitchTest(txt))
tests.append(SimpleLampTest(txt))
tests.append(PhotoTransistorTest(txt))
tests.append(EnvironmentSensorTest(txt))


print(info + "--> Having a total of " + str(len(tests)) + " tasks.\n" + reset)
for i in range(len(tests)):
    print(info + "Executing task " + str(i + 1) + "/" + str(len(tests)) + reset + "\n Info: " + tests[i].brief +
          " ... ", end="", flush=True)
    if not tests[i].does_pass():
        print(failure + "failed!\nDescription: " + tests[i].description + reset)
        print(failure + "\nTests were not successful." + reset)
        exit(1)
        break
    else:
        print(success + "success." + reset, flush=True)
print(success + "\nTests were successful." + reset)
exit(0)

