import fischertechnik.factories as txtFactory
import time


class EnvironmentSensorTest:
    description = "Checks, if the environment sensor is working correctly with its values not fluctuating too much."
    brief = "Checks environment sensor for reasonable values."

    def __init__(self, txt):
        txtFactory.init_i2c_factory()
        self.env_sensor = txtFactory.i2c_factory.create_environment_sensor(txt, 0)

    def does_pass(self):
        temperature = self.env_sensor.get_temperature()
        humidity = self.env_sensor.get_humidity()
        pressure = self.env_sensor.get_pressure()
        for i in range(10):
            time.sleep(1)
            temperature_temp = self.env_sensor.get_temperature()
            humidity_temp = self.env_sensor.get_humidity()
            pressure_temp = self.env_sensor.get_pressure()
            if abs(temperature_temp - temperature) > 1 or abs(humidity_temp - humidity) > 5 or abs(pressure_temp - pressure) > 5:
                return False
            else:
                temperature = temperature_temp
                humidity = humidity_temp
                pressure = pressure_temp
        return True
