import fischertechnik.factories as txtFactory
import time


class PhotoTransistorTest:
    description = "Checks, if a light sensor is working correctly."
    brief = "Checks a light sensor."

    def __init__(self, txt):
        txtFactory.init_input_factory()
        txtFactory.init_output_factory()
        self.photo_transistor = txtFactory.input_factory.create_photo_transistor(txt, 2)
        self.led = txtFactory.output_factory.create_led(txt, 3)

    def does_pass(self):
        self.led.set_brightness(255)
        time.sleep(1)
        state = self.photo_transistor.get_state()
        if state == 0:
            return False
        else:
            return True
