import numbers
import time
import unittest

import fischertechnik.factories as txt_factory
from ControllerInstance import ControllerInstance


class ColorSensorTest(unittest.TestCase):

    def setUp(self):
        self.controller = ControllerInstance.get_instance().get_controller()
        self.color_sensor = txt_factory.input_factory.create_color_sensor(self.controller, 6)
        time.sleep(1)

    def test_get_voltage(self):
        self.assertTrue(isinstance(self.color_sensor.get_voltage(), numbers.Number))
        self.assertTrue(self.color_sensor.get_voltage() > 0)

if __name__ == '__main__':
    unittest.main()
