import fischertechnik.factories as txt_factory


class ControllerInstance():
    controller = None
    __instance = None

    @staticmethod
    def get_instance():
        """ Static access method. """
        if ControllerInstance.__instance == None:
            ControllerInstance()
        return ControllerInstance.__instance

    def __init__(self):
        """ Virtually private constructor. """
        if ControllerInstance.__instance != None:
            raise Exception("This class is a Singleton!")
        else:
            ControllerInstance.__instance = self
            txt_factory.init_controller_factory()
            txt_factory.init_input_factory()
            txt_factory.init_motor_factory()
            txt_factory.init_servomotor_factory()
            txt_factory.init_output_factory()
            txt_factory.init_counter_factory()
            txt_factory.init_i2c_factory()
            txt_factory.init_usb_factory()
            self.controller = txt_factory.controller_factory.create_graphical_controller()

    def get_controller(self):
        return self.controller
