import time
import unittest

import fischertechnik.factories as txt_factory
from ControllerInstance import ControllerInstance


class MiniSwitchTest(unittest.TestCase):

    def setUp(self):
        self.controller = ControllerInstance.get_instance().get_controller()
        self.mini_switch = txt_factory.input_factory.create_mini_switch(self.controller, 8)
        time.sleep(1)

    def test_is_open(self):
        self.assertTrue(self.mini_switch.is_open())

    def test_is_closed(self):
        self.assertFalse(self.mini_switch.is_closed())

    def test_get_state(self):
        self.assertTrue(self.mini_switch.get_state() == 0)

if __name__ == '__main__':
    unittest.main()
