import time
import unittest

import fischertechnik.factories as txt_factory
from ControllerInstance import ControllerInstance


class NTCResistorTest(unittest.TestCase):

    def setUp(self):
        self.controller = ControllerInstance.get_instance().get_controller()
        self.ntc_resistor = txt_factory.input_factory.create_ntc_resistor(self.controller, 1)
        time.sleep(1)

    def test_get_resistance(self):
        self.assertTrue(self.ntc_resistor.get_resistance() > 0)

    def test_get_temperature(self):
        self.assertTrue(self.ntc_resistor.get_temperature() > 0)


if __name__ == '__main__':
    unittest.main()
